public class Alarm extends Thread
{
	String           name;
	boolean          localTimeAwareness;
	String           alarmState;
	int              sleeptime;
	static final int dayMs=24*60*60*1000;
	Master    master;
	AbstractWatchApplication alarmApplication;
	volatile boolean	isLive=false;

	public Alarm(String alarmName, boolean aware, AbstractWatchApplication application, String state, METime time, Master masterObject)
	{
		name=alarmName;
		localTimeAwareness=aware;
		alarmApplication=application;
		alarmState=state;
		master=masterObject;
		sleeptime=time.asMilliseconds();
		while (sleeptime < 0) // set time to be next 'day'
		{
			sleeptime=sleeptime+dayMs;
		}
		while (sleeptime > dayMs) // set time to be next 'day'
		{
			sleeptime=sleeptime-dayMs;
		}
	}

	public void run()
	{
		isLive=true;
		try
		{
			sleep(sleeptime);
		}
	        catch (InterruptedException e) {}
		if (isLive) master.raiseAlarm(this);
	}
	
	public void stopAlarm()
	{
		isLive=false;
	}
}
